unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, AppEvnts, IdIPWatch, IdMappedFTP, IdBaseComponent, IdComponent,
  IdTCPServer, IdMappedPortTCP, ScktComp, fngnetstat, snmp;

type
  TRedirector = class(TForm)
    Server: TServerSocket;
    IdIPWatch1: TIdIPWatch;
    ApplicationEvents1: TApplicationEvents;
    function Gethost (var data:string):string;
    function Getportaremota (var data:string):integer;
    function Getportalocale (var data:string):integer;
    function Getcomando (var data:string):string;
    procedure ApplicationEvents1Exception(Sender: TObject; E: Exception);
    procedure ServerClientRead(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ServerClientError(Sender: TObject;
      Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
      var ErrorCode: Integer);
    procedure IdIPWatch1StatusChanged(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure CreaTCPRedirection (var data:string);
    procedure CreaFTPRedirection (var data:string);
  private
    FConnList :TFnugryIpConnectionList;
     activetcp,activeftp : boolean;
     idTCP: TIdMappedPortTCP;
     idFTP: TIdMappedFTP;
  public
    { Public declarations }
  end;

var
  Redirector: TRedirector;

implementation

{$R *.dfm}



function TRedirector.Gethost (var data:string):string;
var host:string;
    a:integer;
begin
a:= lastdelimiter (' ',data);
host:= Copy (data,12,a-12);
Result:=host;
end;

function TRedirector.Getportaremota (var data:string):integer;
var a,b:integer;
    porta:string;
begin
a:= lastdelimiter (' ',data)+1;
b:= lastdelimiter ('[',data);
porta:= Copy (data,a,b-a);
Result:= strtoint(porta);
end;

function TRedirector.Getportalocale (var data:string):integer;
var a,b:integer;
    porta:string;
begin
a:= lastdelimiter ('[',data)+1;
b:= lastdelimiter (']',data);
porta:= Copy(data,a,b-a);
Result:= strtoint (porta);
end;

function TRedirector.Getcomando (var data:string):string;
begin
Result:= Copy (data,7,4);
end;


procedure TRedirector.ApplicationEvents1Exception(Sender: TObject;
  E: Exception);
begin
// non fare nulla
end;

procedure TRedirector.CreaTCPRedirection (var data:string);
begin
try
idTCP := TIdMappedPortTCP.Create(self);
idTCP.DefaultPort:= getportalocale(data);
idTCP.MappedHost:= gethost(data);
idTCP.MappedPort:= getportaremota(data);
idTCP.Active:=True;
activetcp:=True;
except
    begin
     idTCP.Free;
     idTCP:=nil;
     activetcp:= false;
    end
end;
end;

procedure TRedirector.CreaFTPRedirection (var data:string);
begin
try
idFTP := TIdMappedFTP.Create(self);
idFTP.DefaultPort:= getportalocale(data);
idFTP.MappedHost:= gethost(data);
idFTP.MappedPort:= getportaremota(data);
idFTP.Active:=True;
activeftp:=True;
except
    begin
     idFTP.Free;
     idFTP:=nil;
     activeftp:= false;
    end
end;
end;


procedure TRedirector.ServerClientRead(Sender: TObject;
  Socket: TCustomWinSocket);
var data,S :string;
    i:integer;
begin

data:= Socket.ReceiveText;
if pos('/TCPD',data)=1 then
   begin
      if getcomando(data)='CONN' then
         begin
          if not activetcp then
            begin
             CreaTCPRedirection(data);
             Socket.SendText('Connnessione rediretta a '+gethost(data));
            end
          else Socket.SendText('TCP Redirection gi attiva!');
         end
      else if getcomando(data)='DISC' then
         begin
          if activetcp  then
             begin
               idTCP.Free;
               idTCP:= nil;
               activetcp:= false
             end
          else Socket.SendText('TCP Redirection gi non attiva!');
         end
      else Socket.SendText('Comando '+getcomando(data)+' non supportato');
   end
else if pos('/FTPD',data)=1 then
   begin
      if getcomando(data)='CONN' then
         begin
          if not activeftp then
            begin
             CreaFTPRedirection(data);
             Socket.SendText('Connnessione rediretta a '+gethost(data));
            end
          else Socket.SendText('FTP Redirection gi attiva!');
         end
      else if getcomando(data)='DISC' then
         begin
          if activeftp  then
             begin
               idFTP.Free;
               idFTP:= nil;
               activeftp:= false
             end
          else Socket.SendText('FTP Redirection gi non attiva!');
         end
      else Socket.SendText('Comando '+getcomando(data)+' non supportato');
   end
else if pos('/STAT',data)=1 then
   begin
      if activetcp then Socket.SendText('TCP Redirection attiva sulla porta '+ inttostr (idTCP.DefaultPort)+',Host remoto: '+idTCP.MappedHost+' Porta remota: '+inttostr(idTCP.MappedPort))
      else Socket.SendText('TCP Redirection non attiva');
      if activeftp then Socket.SendText('FTP Redirection attiva sulla porta '+ inttostr (idFTP.DefaultPort)+',Host remoto: '+idFTP.MappedHost+' Porta remota: '+inttostr(idFTP.MappedPort))
      else Socket.SendText('FTP Redirection non attiva');
   end
else  if pos('/NETS',data) = 1 then
   begin

            assert(assigned(FConnList));
            FConnList.Refresh;
            S := format('%-5s %-15s %-4s  %-15s %-4s  %s',
                 ['Proto', 'Local IP', 'Port',
                  'Remote IP', 'Port', 'State']);
              Socket.SendText(S);
              Socket.SendText('');

       for I := 0 to FConnList.ConnCount-1 do
          begin
             with FConnList[I] do
               S := format('%-5s %-15s:%-4d  %-15s:%-4d  %s',
                 [IpProtoName, LocalIpString, LocalPort,
                  RemoteIpString, RemotePort, StateString]);
              Socket.SendText(S);
          end;
   end

else Socket.Disconnect(Socket.SocketHandle);
end;


procedure TRedirector.ServerClientError(Sender: TObject;
  Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
  var ErrorCode: Integer);
begin
Socket.Close;
end;


procedure TRedirector.IdIPWatch1StatusChanged(Sender: TObject);
begin
if IdIPWatch1.IsOnline then Server.Active:=True
  else Server.Active:=False;
end;

procedure TRedirector.FormCreate(Sender: TObject);
begin
FConnList := TFnugryIpConnectionList.Create(Self);
end;

procedure TRedirector.FormDestroy(Sender: TObject);
begin
 if assigned(FConnList) then
      FConnList.Free;
end;

end.
